unit U_HowManyCubes;
{Copyright  2013, Gary Darby,  www.DelphiForFun.org
 This program may be used or modified for any non-commercial purpose
 so long as this original notice remains in place.
 All other rights are reserved
 }



interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  shellAPI, StdCtrls, ComCtrls, Grids, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    StaticText1: TStaticText;
    Panel1: TPanel;
    Memo1: TMemo;
    Button1: TButton;
    Panel2: TPanel;
    Memo2: TMemo;
    Image1: TImage;
    Memo3: TMemo;
    procedure StaticText1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  public
end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var CRLF:char=char($DA);

 procedure TForm1.Button1Click(Sender: TObject) ;
 
 Var
    i,j,k:integer;
    C:array[1..4] of integer;
 begin
   panel2.visible:=true;
   for i:=1 to 4 do C[i]:=0;  {initialize the cube counts}
   for i:=1 to 4 do  {left to right}
   for j:=1 to 4 do {front to back}
   for k:=1 to 4 do  {bottom to top}
   begin
     inc(C[1]);  {count 1x1 cubes - should be 64 of these}
     if (i<4) and (j<4) and (k<4) then inc(C[2]); {generate all 2x2 cubes right and up}
     if (i<3) and (j<3) and (k<3) then inc(C[3]); {count 3x3 if enough room}
     if (i<2) and (j<2) and (k<2) then inc(C[4]); {count 4x4 for the left, front, bottom cube only}
   end;
   memo3.Lines.add (format('There are %d "1x1x1" cubes, %d "2x2x2" cubes,'
   +' %d "3x3x3" cubes, and %d "4x4x4" cube for a total of %d cubes',
   [c[1], c[2], c[3], c[4], C[1]+C[2]+C[3]+C[4]]));
 end;

procedure TForm1.StaticText1Click(Sender: TObject);
begin
  ShellExecute(Handle, 'open', 'http://www.delphiforfun.org/',
  nil, nil, SW_SHOWNORMAL) ;
end;


end.
